﻿//●表組内部の罫線変更.jsx
//					2006.11.29/09:45	修正	(C)CopyRight Mishima Print Co.
//
//	1.このスクリプトを使用して何らかの損害が生じたとしても、責任は負いかねますので、自己責任で使用して下さい。
//	2.このスクリプトを使い易いように、改変、改良をして同一部署ないで使用するのは構いません。
//	3.このスクリプト及び、改変、改良を加えたスクリプトを無償で再配布する場合にはご連絡ください。
//	4.このスクリプト及び、改変、改良を加えたスクリプトを有償で再配布する事は禁止します。
//
//						2006.12.05　三島梅花藻	/ Mishima Print Co.
//						e-mail：tuchiya☆mishima-print.co.jp	（☆を@に置き換えて下さい。）

#target indesign

//測定単位の退避・設定
var myDoc = app.activeDocument;
with (myDoc.viewPreferences){ 
	var myOldXUnits = horizontalMeasurementUnits; 
	var myOldYUnits = verticalMeasurementUnits;
	var myOldTextUnits = textSizeMeasurementUnits;
	var myOldLineUnits = lineMeasurementUnits;
	var myOldTypographUnits = typographicMeasurementUnits;
	horizontalMeasurementUnits = MeasurementUnits.millimeters; 
	verticalMeasurementUnits = MeasurementUnits.millimeters;
	textSizeMeasurementUnits = MeasurementUnits.q;
	lineMeasurementUnits = MeasurementUnits.millimeters;
	typographicMeasurementUnits = MeasurementUnits.ha;
}
// ラベルの横幅
var myLabelWidth = 180;
// コントロールの横幅
var myControlWidth = 60;
// セルの線の線幅デフォルト値
defaultInnerStroke = 0.12;

//２重線（0.12㍉罫線２本からなる0.5㍉の二重線）を追加
var myStrokeType = app.activeDocument.stripedStrokeStyles.item("２重線");
try {
	myStrokeType.name;
} catch (myError){
	myStrokeType = app.activeDocument.stripedStrokeStyles.add({name:"２重線",strokeStyleType:"ストライプ",stripeArray:[0, 24, 76, 100]});
}

var mySel = app.selection[0];
var obj = mySel;
var objname = app.selection[0].constructor.name;
switch (objname){
	case "Cell":
		var RowSpan = mySel.rowSpan;
		var ColumnSpan = mySel.columnSpan;
		var Name = mySel.name;
		obj = obj.parent;
		break;
	case "Table":
		var RowSpan = mySel.rows.length;
		var ColumnSpan = mySel.columns.length;
		var Name = "0:0";
		break;
	default:
		break label;	//labelへGO!
}
var startNr = Name.split(":");
var Cc = eval(startNr[0]);
var Cr = eval(startNr[1]);

var myStorkeStyles = myDoc.strokeStyles.everyItem().name;
var innerStrokeType_init = checkList(myStorkeStyles,"ベタ");
var widthLst = ["0.12","0.25","0.4","0.5"];	//線幅のリスト

with (myDialog = app.dialogs.add({name:"選択範囲内のセルの内部の罫の一括変更"})){
	with(dialogColumns.add()){
		staticTexts.add({staticLabel:"線幅(mm):", minWidth:myLabelWidth});
		staticTexts.add({staticLabel:"線の種類:", minWidth:myLabelWidth});
		staticTexts.add({staticLabel:"変更する罫線:", minWidth:myLabelWidth});
	}
	with(dialogColumns.add()){
		var innerStrokeWidth = realComboboxes.add({editValue:defaultInnerStroke,minimumValue:0,maximumValue:10,smallNudge:0.1,stringList:widthLst});
		var innerStrokeType  = dropdowns.add({stringList:myStorkeStyles,selectedIndex:innerStrokeType_init,minWidth:myControlWidth});
		var columnchecked    = checkboxControls.add({staticLabel: "行(横↓縦←)の罫線", minWidth:myLabelWidth,checkedState:true});
		var rowchecked       = checkboxControls.add({staticLabel: "列(横→縦↓)の罫線", minWidth:myLabelWidth,checkedState:true});
		var outerchecked	 = checkboxControls.add({staticLabel: "外周の罫線", minWidth:myLabelWidth,checkedState:false});
	}
}
if (myDialog.show()){
	with(mySel.cells.itemByRange(0, -1))
	{
		if (columnchecked.checkedState){
			innerColumnStrokeWeight = innerStrokeWidth.editValue;
			innerColumnStrokeType = myStorkeStyles[innerStrokeType.selectedIndex];
		}
		if (rowchecked.checkedState){
			innerRowStrokeWeight = innerStrokeWidth.editValue;
			innerRowStrokeType = myStorkeStyles[innerStrokeType.selectedIndex];
		}
	}
	if (outerchecked.checkedState){
		for (var i=Cc; i < Cc+ColumnSpan; i++){
			app.selection = obj.cells.item(i+":"+Cr);
			var temp = app.selection[0];
			temp.topEdgeStrokeWeight = innerStrokeWidth.editValue;
			temp.topEdgeStrokeType	 = myStorkeStyles[innerStrokeType.selectedIndex];
			//
			app.selection = obj.cells.item(i+":"+(Cr+RowSpan-1));
			var temp = app.selection[0];
			temp.bottomEdgeStrokeWeight	= innerStrokeWidth.editValue;
			temp.bottomEdgeStrokeType	= myStorkeStyles[innerStrokeType.selectedIndex];
		}
		for (var j=Cr; j < Cr+RowSpan; j++){
			app.selection = obj.cells.item(Cc+":"+j);
			var temp = app.selection[0];
			temp.leftEdgeStrokeWeight = innerStrokeWidth.editValue;
			temp.leftEdgeStrokeType   = myStorkeStyles[innerStrokeType.selectedIndex];
			//
			app.selection = obj.cells.item((Cc+ColumnSpan-1)+":"+j);
			var temp = app.selection[0];
			temp.rightEdgeStrokeWeight = innerStrokeWidth.editValue;
			temp.rightEdgeStrokeType   = myStorkeStyles[innerStrokeType.selectedIndex];
		}
		app.selection = mySel;
//		選択されたものがTable全体ならば以下でOK！
//		mySel.rows[0].topEdgeStrokeWeight = innerStrokeWidth.editValue;
//		mySel.rows[0].topEdgeStrokeType	 = myStorkeStyles[innerStrokeType.selectedIndex];
//		mySel.columns[0].leftEdgeStrokeWeight = innerStrokeWidth.editValue;
//		mySel.columns[0].leftEdgeStrokeType   = myStorkeStyles[innerStrokeType.selectedIndex];
//		mySel.columns[-1].rightEdgeStrokeWeight = innerStrokeWidth.editValue;
//		mySel.columns[-1].rightEdgeStrokeType   = myStorkeStyles[innerStrokeType.selectedIndex];
//		mySel.rows[-1].bottomEdgeStrokeWeight	= innerStrokeWidth.editValue;
//		mySel.rows[-1].bottomEdgeStrokeType	= myStorkeStyles[innerStrokeType.selectedIndex];
	}
}
myDialog.destroy();
label:						//ブレークラベル(goto文は構造化プログラミングという点ではダメなんだよなぁ)
with (myDoc.viewPreferences){ 
	try{ 
		horizontalMeasurementUnits = myOldXUnits; 
		verticalMeasurementUnits = myOldYUnits; 
		textSizeMeasurementUnits = myOldTextUnits;
		lineMeasurementUnits = myOldLineUnits;
		typographicMeasurementUnits = myOldTypographUnits;
	} 
	catch(myError){ 
		alert("Could not reset custom measurement units."); 
	}
}

function checkList(List,str){
	for (var i=0; i<List.length; i++){
		if (List[i] == str) return i;
	}
	return 0;
}