﻿//●検索置換設定の保存.jsx
//　InDesignの「検索と置換」の検索文字・置換文字等の設定や検索形式・置換形式の設定を保存するスクリプトです。
//	設定保存ファイルは、このスクリプトのあるフォルダ内にfind_change_preferences.txtというファイル名で作成されます。
//	保存できる設定の数の上限は定めていませんが、ダイアログで表示可能な数が実用上の上限になると思います。
//	現時点では、「ルビのフォントの種類」を「自動」とする設定は保存しても読み込む事ができない事が確認されています。
//	読み込めない（読み込んでも設定としては空欄になってしまう）項目は、再度手作業で形式の設定を入力する必要があります。	
//
//	1.このスクリプトを使用して何らかの損害が生じたとしても、責任は負いかねますので、自己責任で使用して下さい。
//	2.このスクリプトを使い易いように、改変、改良をして同一部署ないで使用するのは構いません。
//	3.このスクリプト及び、改変、改良を加えたスクリプトを無償で再配布する場合にはご連絡ください。
//	4.このスクリプト及び、改変、改良を加えたスクリプトを有償で再配布する事は禁止します。
//
//						2006.12.08　三島梅花藻	/ Mishima Print Co.
//						e-mail：tuchiya☆mishima-print.co.jp	（☆を@に置き換えて下さい。）
							
CR = String.fromCharCode(13);
// 検索・置換設定保存ファイルファイル名
var FCP_FILE_NAME = "find_change_preferences.txt";

// 自身の親ディレクトリを戻すfunction
function scriptPath()
{
	tempArray = new Array();
	tempArray = app.activeScript.toString().split("/");
	return tempArray.slice(0, tempArray.length - 1).join("/") + "/";
}

//主処理
// 検索・置換設定ファイルの存在確認
filename = scriptPath() + FCP_FILE_NAME;
fileObj = new File(filename);

//ダイアログの生成
with(myDialog = app.dialogs.add({name:"検索・置換設定の読み込み・保存"})){
	with(dialogColumns.add()){
		with(borderPanels.add()){
			staticTexts.add({staticLabel:"操作:"});
			with(dialogColumns.add()){
				with(myCmd = radiobuttonGroups.add()){
					radiobuttonControls.add({staticLabel:"保存", checkedState:true});
					if (fileObj.exists){
						radiobuttonControls.add({staticLabel:"読み込み"});
						radiobuttonControls.add({staticLabel:"保存設定の削除"});
					}
				}
			}
		}
	}
}
	
//ダイアログの表示
var myResult = myDialog.show();

if(myResult){
	switch (myCmd.selectedButton){
	case 0 :	//検索・置換設定の保存
		var precomment = app.findPreferences.findText;
		if (precomment == "") precomment = "なし";
		var commentstr = prompt("コメントを入力してください。",precomment);
		//コメントから改行を取り除く。
		var commentArray = commentstr.split(CR);
		var comment = commentArray.join("/");
		var serializeFP = app.findPreferences.properties.toSource();
		var serializeCP = app.changePreferences.properties.toSource();
		var serialize = comment + CR + serializeFP + CR + serializeCP + CR;
		// シリアライズした検索・置換設定をテキストとして書き出し(上書き)
		if (fileObj.open("e")){
			fileObj.seek(0,2);	//ファイルの最後に書き足す
			fileObj.write(serialize);
			fileObj.close();
		} else {
			alert("ファイルが開けませんでした");
		}
		break;
	case 1 :	//検索・置換設定の読み込み
		if(fileObj.exists){
			if(fileObj.open("r")){
				var commentArray = new Array();
				var findPreferencesArray = new Array();
				var changePreferencesArray = new Array();
				var i = 0;
				while (!fileObj.eof){
					commentArray[i] = fileObj.readln();
					findPreferencesArray[i] = fileObj.readln();
					changePreferencesArray[i] = fileObj.readln();
					i++;
				}
				fileObj.close();
				//ダイアログの生成
				with(myDialog2 = app.dialogs.add({name:"読み込む保存設定を選択してください"})){
					with(dialogColumns.add()){
						with(mySel = radiobuttonGroups.add()){
							var chkst = true;
							for (var j = 0; j < i-1; j++){
								radiobuttonControls.add({staticLabel:commentArray[j],checkedState:chkst});
								chkst = false;
							}
						}
					}
				}
				var myResult2 = myDialog2.show();
				if (myResult2){
					app.findPreferences.properties = eval(findPreferencesArray[mySel.selectedButton]);
					app.changePreferences.properties = eval(changePreferencesArray[mySel.selectedButton]);
					if (app.findPreferences.kerningMethod=="None") app.findPreferences.kerningMethod = 1851876449;
					if (app.changePreferences.kerningMethod=="None") app.changePreferences.kerningMethod = 1851876449;
				}
			} else {
				alert("ファイルが開けませんでした");
			}
		}
		break;
	case 2 :	//保存設定の削除
		if(fileObj.exists){
			if(fileObj.open("r")){
				var commentArray = new Array();
				var findPreferencesArray = new Array();
				var changePreferencesArray = new Array();
				var i = 0;
				while (!fileObj.eof){
					commentArray[i] = fileObj.readln();
					findPreferencesArray[i] = fileObj.readln();
					changePreferencesArray[i] = fileObj.readln();
					i++;
				}
				fileObj.close();
				//ダイアログの生成
				with(myDialog2 = app.dialogs.add({name:"削除する保存設定にチェック"})){
					with(dialogColumns.add()){
						var chkD = new Array();
						for (var j = 0; j < i-1; j++){
							chkD[j] = checkboxControls.add({staticLabel:commentArray[j]});
						}
					}
				}
				var myResult2 = myDialog2.show();
				if (myResult2){	//チェックされた項目以外を保存
					if(fileObj.open("w")){
						var removeflag = true;
						for (var j=0; j < i-1; j++){
							if (!chkD[j].checkedState){
								var serialize = commentArray[j]+CR+findPreferencesArray[j]+CR+changePreferencesArray[j]+CR;
								fileObj.write(serialize);
								removeflag = false;
							}
						}
						if (removeflag){	//検索・置換設定ファイルの削除
							fileObj.remove();
						}
					} else {
						alert("ファイルが開けませんでした");
					}
				}
				myDialog2.destroy();
			} else {
				alert("ファイルが開けませんでした");
			}
		}
		break;
	}
}

//ダイアログの削除
myDialog.destroy();
