﻿//●下線でアミ掛け.jsx
//	InDesignの下線機能を用いてアミ掛けを行うスクリプトです。
//	アミ掛けを行うテキスト部分を選択してスクリプトを実行してください。
//	選択範囲の先頭文字の前のアキ量と最後の文字の後ろのアキ量を設ける事でアミ掛け範囲を前後にも広げています。
//	モリサワFONTを基準に作っていますので、ベースラインの位置が仮想ボディ下端から12％（仮想ボディの中央から38％）で計算しています。
//	MathMagicのmmaCenturyはベースラインが17％の位置で、モリサワFONTに対してベースラインを５％下げる事で一致するようです。
//	上下のカーソルキーで値の増減ができます。
//										2006.11.18/15:40 修正	(C)CopyRight Mishima Print Co.
//
//	1.このスクリプトを使用して何らかの損害が生じたとしても、責任は負いかねますので、自己責任で使用して下さい。
//	2.このスクリプトを使い易いように、改変、改良をして同一部署ないで使用するのは構いません。
//	3.このスクリプト及び、改変、改良を加えたスクリプトを無償で再配布する場合にはご連絡ください。
//	4.このスクリプト及び、改変、改良を加えたスクリプトを有償で再配布する事は禁止します。
//
//						2006.12.08　三島梅花藻	/ Mishima Print Co.
//						e-mail：tuchiya☆mishima-print.co.jp	（☆を@に置き換えて下さい。）

if (app.documents.length != 0){
	if (app.selection.length == 1){
		switch (app.selection[0].constructor.name){
			case "Text":
			case "Character":
			case "Word":
			case "Line":
			case "TextStyleRange":
			case "Paragraph":
			case "TextColumn":
				myDisplayDialog();
				break;
			default:
				alert("選択された部分はテキストではありません。テキストを範囲指定してください。");
				break;
		}
	}
	else{
		alert("テキスト部分を選択し直してください。");
	}
}
else{
	alert("No documents are open. Please open a document, select some text, and try again.");
}
function myDisplayDialog(){
	var myDoc = app.activeDocument;
	with (myDoc.viewPreferences){ 
		var myOldXUnits = horizontalMeasurementUnits; 
		var myOldYUnits = verticalMeasurementUnits;
		var myOldTypographUnits = typographicMeasurementUnits;
		var myOldTextUnits = textSizeMeasurementUnits;
		var myOldLineUnits = lineMeasurementUnits;
		//水平方向および垂直方向の測定単位を mm に、組版の測定単位をを 歯 に、テキストサイズをの測定単位を 級 に、線幅の測定単位を mm に設定します。
		horizontalMeasurementUnits = MeasurementUnits.millimeters; 
		verticalMeasurementUnits = MeasurementUnits.millimeters;
		typographicMeasurementUnits = MeasurementUnits.ha;
		textSizeMeasurementUnits = MeasurementUnits.q;
		lineMeasurementUnits = MeasurementUnits.millimeters;
	}
	var myStory = app.selection[0].parentStory;
	var myFontSize = app.selection[0].characters[0].pointSize; 
	var mFontSize = eval(myFontSize);
	var mySwatches = app.activeDocument.swatches;
	var SwatcheList = app.activeDocument.swatches.everyItem().name;
	var myDialog;
	var ulWidthLst = ["1.00","1.20","1.25","1.334"];	//幅(×倍)
	var ulLengthLst = ["0","0.125","0.167","0.25","0.334","0.5"];	//前後のアキ量設定
	var baselineLst = ["12","14","17"];		//ベースライン位置(％)のリスト
	with(myDialog = app.dialogs.add({name:"下線でアミ掛けスクリプト"})){
		with(dialogColumns.add()){
			with(dialogRows.add()){
				with(dialogColumns.add()){	// ラベル類の列
					staticTexts.add({staticLabel:"幅(×倍):"});
					staticTexts.add({staticLabel:"前後のアキ量設定:"});
					staticTexts.add({staticLabel:"カラー:"});
					staticTexts.add({staticLabel:"濃淡(％):"});
					staticTexts.add({staticLabel:"文字カラー:"});
					staticTexts.add({staticLabel:"ベースライン位置(％):"});
				}
				with(dialogColumns.add()){	// コントロール類の列
					ulWidth = realComboboxes.add({editValue:1.25,minimumValue:0,maximumValue:400,smallNudge:0.05,stringList:ulWidthLst});
					ulLength = realComboboxes.add({editValue:0.125,minimumValue:0,maximumValue:10,smallNudge:0.005,stringList:ulLengthLst});
					ulSwatch = dropdowns.add({stringList:SwatcheList, selectedIndex:4});
					ulTint = realEditboxes.add({editValue:100,minimumValue:0,maximumValue:100,smallNudge:10});
					textSwatch = dropdowns.add({stringList:SwatcheList, selectedIndex:2});
					BaseLined = realComboboxes.add({editValue:12,minimumValue:0,maximumValue:100,smallNudge:1,stringList:baselineLst});
				}
			}
		}
	}
	myReturn = myDialog.show();
	if (myReturn) {
		var baselines = (50 - BaseLined.editValue)/100.0;
		with (app.selection[0].characters.everyItem()){
			underline = true;
			underlineOffset = - mFontSize*baselines/4;
			underlineType = "ベタ";	
			underlineWeight = mFontSize*ulWidth.editValue/4;
			underlineColor = mySwatches[ulSwatch.selectedIndex].name;
			underlineTint = ulTint.editValue;
			fillColor = mySwatches[textSwatch.selectedIndex].name;
		}
		app.selection[0].characters[0].leadingAki = ulLength.editValue;
		app.selection[0].characters[-1].trailingAki = ulLength.editValue;
		for (var i=0;i<app.selection[0].characters.length;i++){// ベースラインシフト、文字級数、文字揃え位置に対する修正（但し、文字揃え位置は現時点では下記の３つのみ対応）
			with (app.selection[0].characters[i]){
				underlineOffset += baselineShift/4;
				if (pointSize != mFontSize){
					var doffset = 0;
					switch (characterAlignment){
					case 1247896436:	//仮想ボディの中央
						doffset = (mFontSize-pointSize)*baselines/4;
						break;
					case 1247900784:	//仮想ボディの上/右
						doffset = (mFontSize-pointSize)*(0.5+baselines)/4;
						break;
					case 1247896173:	//仮想ボディの下/左
						doffset = -(mFontSize-pointSize)*(0.5-baselines)/4;
						break;
					}
					underlineOffset += doffset;
				}
			}
		}
	}
	with (myDoc.viewPreferences){ 
		try{ 
			horizontalMeasurementUnits = myOldXUnits; 
			verticalMeasurementUnits = myOldYUnits; 
			typographicMeasurementUnits = myOldTypographUnits;
			textSizeMeasurementUnits = myOldTextUnits;
			lineMeasurementUnits = myOldLineUnits;
		} 
		catch(myError){ 
			alert("Could not reset custom measurement units."); 
		}
	}
}