﻿//●そのままアンカー付きオブジェクト化.jsx
//
//	ドキュメント上に置かれただけのページアイテムをその位置のままでアンカー付きオブジェクトにするスクリプト
//			アンカーを挿入する位置（テキスト内）にカーソルを立てて実行。
//			ページアイテム（テキストフレーム、グラフィックライン、ポリゴン、グループ等のオブジェクト）の
//			左上の座標の近いものから順に選択されるので、選択されたページアイテムが違う場合には、"No"のボタンを
//			クリックして次を表示させて下さい。
//		重要：アンカー付きオブジェクト化するためにライブラリに一時的登録しますので、ライブラリーをひとつ開いて
//			おくか、スクリプトと同じフォルダに"temp.indl"という名前でInDesignのライブラリを作っておいて下さい。
//								2006.12.05　9：40修正		(C)CopyRight Mishima Print Co.
//											(2006.12.05:参照ポイントを追加)
//
//	1.このスクリプトを使用して何らかの損害が生じたとしても、責任は負いかねますので、自己責任で使用して下さい。
//	2.このスクリプトを使い易いように、改変、改良をして同一部署ないで使用するのは構いません。
//	3.このスクリプト及び、改変、改良を加えたスクリプトを無償で再配布する場合にはご連絡ください。
//	4.このスクリプト及び、改変、改良を加えたスクリプトを有償で再配布する事は禁止します。
//
//						2006.12.08　三島梅花藻	/ Mishima Print Co.
//						e-mail：tuchiya☆mishima-print.co.jp	（☆を@に置き換えて下さい。）

#target indesign
TATEGAKI = 1986359924;
function achorObject(pi,distance){	//カーソルを立てた挿入点からの距離で、ページアイテムを並べ換えるためのクラス
	this.pageItem = pi;
	this.id = pi.id;
	this.distance = distance;
}
//測定単位の退避・設定
var myDoc = app.activeDocument;
with (myDoc.viewPreferences){ 
	var myOldXUnits = horizontalMeasurementUnits; 
	var myOldYUnits = verticalMeasurementUnits;
	var myOldTextUnits = textSizeMeasurementUnits;
	var myOldLineUnits = lineMeasurementUnits;
	var myOldTypographUnits = typographicMeasurementUnits;
	horizontalMeasurementUnits = MeasurementUnits.millimeters; 
	verticalMeasurementUnits = MeasurementUnits.millimeters;
	textSizeMeasurementUnits = MeasurementUnits.q;
	lineMeasurementUnits = MeasurementUnits.millimeters;
	typographicMeasurementUnits = MeasurementUnits.ha;
}
var zoom = app.activeWindow.zoomPercentage;	//選択したオブジェクトを中心に再描画するために、現在の拡大率を記憶
var myLibraries = app.libraries;	//一時的にライブラリにオブジェクトを登録するためライブラリを開く
if (app.selection[0].constructor.name=="InsertionPoint"){
	with (myDialog = app.dialogs.add({name:"そのままアンカー付きオブジェクト化"})){
		with(dialogColumns.add()){
			with(dialogRows.add()){
				with(dialogColumns.add()){
					staticTexts.add({staticLabel:"参照ポイント"});
				}
				with(dialogColumns.add()){
					with(hRefPoint = radiobuttonGroups.add()){
						radiobuttonControls.add({staticLabel:"アンカーマーカー", checkedState:true});
						radiobuttonControls.add({staticLabel:"列枠"});
						radiobuttonControls.add({staticLabel:"テキストフレーム"});
						radiobuttonControls.add({staticLabel:"ページマージン"});
						radiobuttonControls.add({staticLabel:"ページ枠"});
					}
				}
			}
		}
	}
	if (myDialog.show()){
		var myIns = app.selection[0];							//アンカーの挿入点
		var myStory = app.selection[0].parentStory;				//カーソルを立てたストーリー
		var myTextFrame = app.selection[0].parentTextFrames[0];	//　〃　テキストフレーム
		app.selection = myTextFrame;
		var mypage = app.activeWindow.activeSpread;				//アクティブページをアクティブスプレッドに変更（2006.11.9）
		app.selection = NothingEnum.nothing;					//選択解除
		var tategakiFlag = false;
		if (myStory.storyPreferences.storyOrientation==TATEGAKI) tategakiFlag = true;
		var ax = myIns.horizontalOffset;
		var ay = myIns.baseline;

		var checkItems = new Array();
		for (var i=0; i < mypage.pageItems.length; i++){
			if (tategakiFlag){		//縦書き
				var dx = mypage.pageItems[i].geometricBounds[3] - ax;
			} else {				//横書き
				var dx = mypage.pageItems[i].geometricBounds[1] - ax;
			}
			var dy = mypage.pageItems[i].geometricBounds[0] - ay;
			var distance = dx*dx + dy*dy;
			checkItems.push(new achorObject(mypage.pageItems[i],distance));
		}
		checkItems.sort(sortdistance);							//カーソル位置に近い順に並べ直し
		for (var i=0;i < checkItems.length; i++){
			if (checkItems[i].id != myTextFrame.id){
				app.selection = checkItems[i].pageItem;
				app.activeWindow.zoomPercentage = zoom;
				if (confirm("これをアンカー付きオブジェクトにしますか OK?")){
					//一時的に登録する為のライブラリを指定する
					if (myLibraries.length != 0){
						myLib = myLibraries.firstItem();
					} else {									//ライブラリが開いていない場合、temp.indlを開く
						var myScriptFileName = app.activeScript;
						var myScriptFile = File(myScriptFileName);
						var myFolder = myScriptFile.parent;
						var filename = myFolder.getFiles("temp.indl")[0];
						try {
							myLib = app.open(filename);			//temp.indlが存在する場合
						}
						catch(e) {
							myLib = myLibraries.add(filename);	//これだと上手くない。どうしたものかな？
						}
					}
					//ここまでがライブラリを指定する処理
					with (checkItems[i].pageItem){				//アンカー付きオブジェクトにするページアイテムの左上の位置を記憶
						var myPageItemPosition = new Array(geometricBounds[0],geometricBounds[1]);
						var myabsoluteRotationAngle = absoluteRotationAngle;
					}
					var myAsset = checkItems[i].pageItem.store(myLib);	//ライブラリに一時登録
					checkItems[i].pageItem.remove();			//ページアイテムを削除
					app.selection = myIns;						//挿入点を選択
					var myObjA = myAsset.placeAsset(app.activeDocument);	//ドキュメント内に配置
					var myObj = myObjA[0];
					with (myObj.parent){						//アンカーマーカーの前後のアキ量をベタにする
						leadingAki = 0;
						trailingAki = 0;
					}
					with (myObj.anchoredObjectSettings){
						anchoredPosition = AnchorPosition.anchored;
						anchorPoint = AnchorPoint.topLeftAnchor;
						horizontalAlignment = HorizontalAlignment.centerAlign;
						switch (hRefPoint.selectedButton){ 
							case 0: //"アンカーマーカー"
								horizontalReferencePoint = AnchoredRelativeTo.anchorLocation;
								break;
							case 1: //"列枠"
								horizontalReferencePoint = AnchoredRelativeTo.columnEdge;
								break;
							case 2: //"テキストフレーム"
								horizontalReferencePoint = AnchoredRelativeTo.textFrame;
								break;
							case 3: //"ページマージン"
								horizontalReferencePoint = AnchoredRelativeTo.pageMargins;
								break;
							case 4: //"ページ枠"
								horizontalReferencePoint = AnchoredRelativeTo.pageEdge;
								break;
						}
						pinPosition = false;
						verticalAlignment = VerticalAlignment.topAlign;
						lockPosition = false;
					}
					app.activeWindow.zoomPercentage = zoom;
					if (tategakiFlag){
						try{myObj.rotationAngle = myabsoluteRotationAngle;}
						catch(e){alert(e);myObj.rotationAngle = myabsoluteRotationAngle;}
						app.activeWindow.zoomPercentage = zoom;
					}
					with (myObj){								//アンカー付きオブジェクト化したページアイテムの位置
						var newPageItemPosition = new Array(geometricBounds[0],geometricBounds[1]);
					}
					with (myObj.anchoredObjectSettings){		//アンカー付きオブジェクトのオフセットを計算
						if (tategakiFlag){
							anchorXoffset =	- (myPageItemPosition[0] - newPageItemPosition[0]) / 25.4 * 72;
							anchorYoffset = - (myPageItemPosition[1] - newPageItemPosition[1]) / 25.4 * 72;
						} else {
							anchorYoffset =	(myPageItemPosition[0] - newPageItemPosition[0]) / 25.4 * 72;
							anchorXoffset = (myPageItemPosition[1] - newPageItemPosition[1]) / 25.4 * 72;
						}
						lockPosition = true;					//間違って動かしてしまわないようにロックする
					}
					myAsset.remove();							//ライブラリから除去
					break;										//このbreakでforループを抜ける
				}
			}
		}
		app.selection = NothingEnum.nothing;	//選択解除
	}
	myDialog.destroy();
} else {
	alert("アンカーを入れる挿入点にカーソルを立ててください。");
}
with (myDoc.viewPreferences){ 
	try{ 
		horizontalMeasurementUnits = myOldXUnits; 
		verticalMeasurementUnits = myOldYUnits; 
		textSizeMeasurementUnits = myOldTextUnits;
		lineMeasurementUnits = myOldLineUnits;
		typographicMeasurementUnits = myOldTypographUnits;
	} 
	catch(myError){ 
		alert("Could not reset custom measurement units."); 
	}
}

function sortdistance(a,b){
	return (a.distance - b.distance);
}
